/*
	$Id: resourceoption.h,v 1.5 2001/04/10 14:24:30 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! clanCore="Resources"

#ifndef header_resourceoption
#define header_resourceoption

#include <vector>
#include <string>

class CL_ResourceOption
{
//!Construction:
public:
	CL_ResourceOption(const std::string &name, const std::string &value)
	: name(name)
	{
		values.push_back(value);
	}

	CL_ResourceOption(const std::string &name)
	: name(name)
	{
	}

	CL_ResourceOption()
	{
	}

//!Attributes:
public:
	const std::string &get_name() const { return name; }

	const std::string &get_value(int i=0) const { return values[i]; }

	std::vector<std::string> &get_values() { return values; }

//!Operations:
public:
	void add_value(const std::string &value) { values.push_back(value); }

//!Implementation:
private:
	std::string name;
	std::vector<std::string> values;
};

#endif
