/*
	$Id: resourceoptions.h,v 1.5 2001/04/10 14:24:30 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! clanCore="Resources"

#ifndef header_resourceoptions
#define header_resourceoptions

#include <map>
#include <string>
#include "resourceoption.h"

class CL_ResourceManager;

class CL_ResourceOptions
{
//!Construction:
public:
	CL_ResourceOptions();

	~CL_ResourceOptions();

//!Attributes:
public:
	std::map<std::string, CL_ResourceOption> &get_options();
	// Returns a list of all the resource options.

	CL_ResourceOption &get_option(const std::string &name);
	// Returns a resource option.

	const CL_ResourceOption &get_option(const std::string &name) const;
	// Returns a resource option.

	bool exists(const std::string &name);
	// Returns true if an option exists.

//!Operations:
public:
	void add(const CL_ResourceOption &option);
	// Add a resource option.

//!Implementation:
private:
	std::map<std::string, CL_ResourceOption> options;
};

#endif
