
//! clanCore="Resources"

#ifndef header_resourcetype_boolean
#define header_resourcetype_boolean

#include "resourcedata.h"
#include "resource_manager.h"
#include "resource.h"
#include <string>

class CL_ResourceData_Boolean : public CL_ResourceData
{
//!Construction:
public:
	CL_ResourceData_Boolean(class CL_Resource &resource);

//!Attributes:
public:
	bool value;
};

class CL_Boolean
{
//!Construction:
public:
	CL_Boolean(const std::string &res_id, CL_ResourceManager *resources)
	{
		CL_Resource res = resources->get_resource(res_id);
		res.load();
		CL_ResourceData_Boolean *data = (CL_ResourceData_Boolean *) res.get_data("boolean");
		value = data->value;
		res.unload();
	}

	CL_Boolean(const std::string &res_id, CL_ResourceManager *resources, bool def_value)
	{
		try
		{
			CL_Resource res = resources->get_resource(res_id);
			res.load();
			CL_ResourceData_Boolean *data = (CL_ResourceData_Boolean *) res.get_data("boolean");
			value = data->value;
			res.unload();
		}
		catch (CL_Error err)
		{
			value = def_value;
		}
	}

	operator bool() const
	{
		return value;
	}

private:
	bool value;
};

#endif
