
//! clanCore="Resources"

#ifndef header_resourcetype_integer
#define header_resourcetype_integer

#include "resourcedata.h"
#include "resource_manager.h"
#include "resource.h"
#include <string>

class CL_ResourceData_Integer : public CL_ResourceData
{
//!Construction:
public:
	CL_ResourceData_Integer(class CL_Resource &resource);

//!Attributes:
public:
	int value;
};

class CL_Integer
{
//!Construction:
public:
	CL_Integer(const std::string &res_id, CL_ResourceManager *resources)
	{
		CL_Resource res = resources->get_resource(res_id);
		res.load();
		CL_ResourceData_Integer *data = (CL_ResourceData_Integer *) res.get_data("integer");
		value = data->value;
		res.unload();
	}

	CL_Integer(const std::string &res_id, CL_ResourceManager *resources, int def_value)
	{
		try
		{
			CL_Resource res = resources->get_resource(res_id);
			res.load();
			CL_ResourceData_Integer *data = (CL_ResourceData_Integer *) res.get_data("integer");
			value = data->value;
			res.unload();
		}
		catch (CL_Error err)
		{
			value = def_value;
		}
	}

	operator int() const
	{
		return value;
	}

private:
	int value;
};

#endif
