
//! clanCore="Resources"

#ifndef header_resourcetype_raw
#define header_resourcetype_raw

#include "resourcedata.h"
#include "resource_manager.h"
#include "resource.h"
#include <string>
#include <vector>

class CL_ResourceData_Raw : public CL_ResourceData
{
//!Construction:
public:
	CL_ResourceData_Raw(class CL_Resource &resource);

//!Attributes:
public:
	std::vector<unsigned char> value;

//!Implementation:
private:
	void on_load_file();
	void on_load_datafile(class CL_InputSourceProvider *provider);
	void on_save_datafile(class CL_OutputSourceProvider *provider);
	void on_unload();

	CL_Slot slot_load_file;
	CL_Slot slot_load_datafile;
	CL_Slot slot_save_datafile;
	CL_Slot slot_unload;
};

class CL_Raw
{
//!Construction:
public:
	CL_Raw(const std::string &res_id, CL_ResourceManager *resources)
	{
		res = resources->get_resource(res_id);
		res.load();
		data = (CL_ResourceData_Raw *) res.get_data("raw");
	}
	
	~CL_Raw()
	{
		res.unload();
	}

	std::vector<unsigned char> &get_data()
	{
		return data->value;
	}

	const std::vector<unsigned char> &get_data() const
	{
		return data->value;
	}

private:
	CL_Resource res;
	CL_ResourceData_Raw *data;
};

#endif
