
#ifndef header_console_window
#define header_console_window

#include <string>

class CL_ConsoleWindow
// Text console window.
// Note: This class has not effect under Linux.
{
//!Construction:
public:
	CL_ConsoleWindow(
		const std::string &title,
		int width = 80,
		int height = 25);
	// Constructs a console window.

	~CL_ConsoleWindow();

//!Operations:
public:
	void redirect_stdio();
	// Redirects stdout, stdin and stderr to the console window.

	void redirect_stdio(const std::string &filename);
	//Redirects stdout and stderr to filename.

	void wait_for_key();
	// Waits until user hits a key.

	void display_close_message();
	// Displays 'press any key to close this console window',
	// and waits until user hits a key.

//!Implementation:
private:
	class CL_ConsoleWindow_Generic *impl;
};

#endif
