
//! clanCore="System"

#ifndef header_event_listener
#define header_event_listener

class CL_EventTrigger;

class CL_EventListener
// The event listener is used to collect a set of events, identified as CL_EventTrigger,
// and wait for one of them to occour. This is analog to the lowlevel C socket select()
// function, except that this one operates on clanlib objects.
{
//!Construction:
public:
	CL_EventListener();
	// Constructs an empty event listener object.

	CL_EventListener(CL_EventTrigger *trigger);
	// Constructs an event listener with one trigger in it.

	virtual ~CL_EventListener();

//!Attributes:
public:

//!Operations:
public:
	void add_trigger(CL_EventTrigger *trigger);
	// Adds an event trigger to the listener.

	void remove_trigger(CL_EventTrigger *trigger);
	// Removes an event trigger from the listener.

	void clear();
	// Removes all event triggers from the listener.

	void reset_all();
	// Resets all event triggers added to the listener.

	bool wait(int timeout = -1);
	// Wait until one of the events triggers. The timeout is in milliseconds.
	// Returns true if an event triggered, false if it timed out.

//!Implementation:
private:
	class CL_EventListener_Generic *impl;
};

#endif
