
//! clanCore="System"

#ifndef header_event_trigger
#define header_event_trigger

class CL_EventListener;
class CL_EventTrigger_Generic;

class CL_EventTrigger
// ClanLib Event trigger. This class represents an event that can be trigged.
// Collect several triggers together using the CL_EventListener class, and then
// call the CL_EventListener::wait function to sleep until one of the events
// are trigged.
{
//!Construction:
public:
	CL_EventTrigger();
	// Constructs an event trigger object.

	virtual ~CL_EventTrigger();

//!Attributes:
public:
	bool get_flag() const;
	// Returns true if the trigger flag has been raised.

//!Operations:
public:
	void reset() const;
	// Reset trigger flag.

	void set_flag();
	// Raise trigger flag.

	bool wait(int timeout = -1);
	// Wait until one of the event triggers. The timeout is in milliseconds.
	// Returns true if the event triggered, false if it timed out.

//!Implementation:
public:
	CL_EventTrigger_Generic *impl;
};

#endif
