/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Controls"

#ifndef header_checkbox
#define header_checkbox

#include "button.h"

class CL_CheckBox : public CL_Button
//: CheckBox component
{
//!Construction:
public:
	CL_CheckBox(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_CheckBox(
		const CL_Point &pos,
		const std::string &text,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	virtual ~CL_CheckBox();

//!Attributes:
public:
	bool is_checked() const;
	//: Returns true if the checkbox is checked, or false if it is not checked.

//!Operations:
public:
	void set_checked(bool check);
	//: Checks the checkbox if check is true, or unchecks it if check is false. 

//!Implementation:
private:
	// TODO:Fix this copy constructor:
	CL_CheckBox(const CL_CheckBox &copy);// : CL_Button(NULL, NULL, NULL) { return; } // disallow copy construction.
	class CL_CheckBox_Generic *impl;
};  

#endif
