/*

	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Framework"

#ifndef header_component_manager
#define header_component_manager

#include "component.h"
#include "component_type.h"

#include <string>
#include <map>

class CL_StyleManager;
class CL_ResourceManager;
class CL_ComponentType;

class CL_ComponentManager
//: Manages the components
{
public:
	static CL_ComponentManager *create(
		const char *resource_id,
		CL_ResourceManager *res_manager,
		CL_StyleManager *style);

	static CL_ComponentManager *create(
		const char *filename,
		bool is_datafile,
		CL_StyleManager *style);
		
	virtual ~CL_ComponentManager() { return; }	

	virtual CL_Component *get_component(const char *component_id) = 0;

	static std::map<std::string, CL_ComponentType *> component_types;
};

#endif
