/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Controls"

#ifndef header_file_dialog
#define header_file_dialog

#include "component.h"

class CL_FileDialog : public CL_Component
//: File dialog component
{
public:
//!Construction:
	CL_FileDialog(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_FileDialog(
		const std::string &path,
		const std::string &filter,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	virtual ~CL_FileDialog();

public:
//!Attributes:

public:
//!Operations:
	void set_path(const std::string &path);
	void set_filter(const std::string &filter);

public:
//!Signals:
	CL_Signal_v1<const std::string &> &sig_ok();
	CL_Signal_v0 &sig_cancel();	

//!Implementation:
private:
	CL_FileDialog(const CL_FileDialog &copy) : CL_Component(NULL, NULL) { return; } // disallow copy construction.
	class CL_FileDialog_Generic *impl;
};

#endif
