/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Controls"

#ifndef header_frame
#define header_frame

#include "component.h"

class CL_Frame : public CL_Component
//: Frame component
{
//!Construction:
public:
	CL_Frame(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_Frame(
		const CL_Rect &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	virtual ~CL_Frame();

//!Attributes:
public:
	bool is_fill_enabled() const;

//!Operations:
public:
	void enable_fill(bool enabled = true);

//!Signals:
public:

//!Implementation:
private:
	CL_Frame(const CL_Frame &copy) : CL_Component(NULL, NULL) { return; } // disallow copy construction.
	class CL_Frame_Generic *impl;
};  

#endif
