/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Controls"

#ifndef header_label
#define header_label

#include "component.h"

class CL_Label : public CL_Component
//: Label component
{
//!Construction:
public:
	CL_Label(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_Label(
		const CL_Point &pos,
		const std::string &text,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_Label(
		const CL_Rect &pos,
		const std::string &text,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	virtual ~CL_Label();

//!Attributes:
public:
	const std::string &get_text() const;
	//: Returns the labeltext.

	int get_alignment() const;
	//: Returns the alignment setting.
	// See set_alignment() for more info.

//!Operations:
public:
	void set_text(const std::string &text);
	//: Sets the labeltext.

	void set_text(int number);
	//: Sets the label contents to a plain text containing the printed value of num.

	void set_text(double number);
	//: Sets the label contents to a plain text containing the printed value of num.

	void clear();
	//: Clears any label contents. Equivalent with setText("").

	void set_alignment(int alignment);
	//: Sets the alignment of the label contents

//!Signals:
public:

//!Implementation:
private:
	CL_Label(const CL_Label &copy) : CL_Component(NULL, NULL) { return; } // disallow copy construction.
	class CL_Label_Generic *impl;
};  

#endif
