/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Controls"

#ifndef header_popupmenu
#define header_popupmenu

#include "menudata.h"

class CL_PopupMenu : public CL_MenuData
//: Popupmenu component
{
public:
//!Construction:
	CL_PopupMenu(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_PopupMenu(
		const class CL_Point &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	virtual ~CL_PopupMenu();

public:
//!Attributes:

public:
//!Operations:

public:
//!Signals:
	CL_Signal_v0 &sig_cancelled();
	//: This signal is emitted when the popupmenu is cancelled.

	CL_Signal_v1<int /*itemid*/> &sig_clicked();
	//: This signal is emitted when an item is clicked in the menu.
	//!param: int itemid - The id of the item clicked

//!Implementation:
private:
//	CL_PopupMenu(const CL_PopupMenu &copy) : CL_MenuData(NULL, NULL) { return; } // disallow copy construction.
	class CL_PopupMenu_Generic *impl;
};  

#endif
