/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Controls"

#ifndef header_progressbar
#define header_progressbar

#include "component.h"

class CL_ComponentOptions;
class CL_Rect;

class CL_ProgressBar : public CL_Component
//: ProgressBar component
{
//!Construction:
public:
	CL_ProgressBar(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_ProgressBar(
		const CL_Rect &pos,
		int steps,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	virtual ~CL_ProgressBar();

//!Attributes:
public:
	int get_steps() const;
	//: Returns the total number of steps.

	int get_progress() const;
	//: Returns the current amount of progress.

	float get_percentage() const;
	//: Returns the current amount of progress in percentage.

//!Operations:
public:
	void set_steps(int total_steps);
	//: Sets the total number of steps to total_steps. 

	void set_progress(int progress);
	//: Sets the current amount of progress of the total number of steps. 

	void increase(int steps = 1);
	//: Progresses the bar with steps.

	void reset();
	//: Reset the progress bar. The progress bar `rewinds'. 

//!Signals:
public:

//!Implementation:
private:
	CL_ProgressBar(const CL_ProgressBar &copy) : CL_Component(NULL, NULL) { return; } // disallow copy construction.
	class CL_ProgressBar_Generic *impl;
};

#endif
