/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Framework"

#ifndef header_stylemanager
#define header_stylemanager

#include <string>

class CL_ComponentOptions;
class CL_Component;
class CL_ResourceManager;
class CL_StyleManager_Generic;

class CL_StyleManager
//:Manages the overall style of the system
{
// Construction:
public:
	CL_StyleManager(CL_ResourceManager *resources);
	virtual ~CL_StyleManager();

// Attributes:
public:
	CL_ResourceManager *get_resources();

// Overrideables:
public:
	virtual CL_Component *create_component(
		const std::string &type,
		const CL_ComponentOptions &options,
		CL_Component *parent)=0;

	virtual void connect_styles(
		const std::string &type,
		const CL_ComponentOptions &options,
		CL_Component *owner)=0;

// Implementation:
private:
	CL_StyleManager(const CL_StyleManager &copy) { return; } // disallow copy contruction
	CL_StyleManager_Generic *impl;
};

#endif
