/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

//! clanGUI="Controls"

#ifndef header_window
#define header_window

#include "component.h"

class CL_Window : public CL_Component
//: Window component
{
//!Construction:
public:
	CL_Window(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	// Creates a window using the parameters passed in the 'options' structure.

	CL_Window(
		const CL_Rect &pos,
		const std::string &title,
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	// Creates a window located at the given position.
	
	CL_Window(
		const CL_Rect &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	// Creates a window located at the given position.

	virtual ~CL_Window();

//!Attributes:
public:
	CL_Component *get_client_area() const;
	// Returns the client area of the component.

	const std::string &get_title() const;
	// Returns the window title.

//!Operations:
public:
	void set_title(const std::string &text);
	// Sets the window title.

	void set_client_size(int width, int height);
	// Sets the size of the client area, and resizes the window accordingly.

//!Signals:
public:

//!Implementation:
private:
	CL_Window(const CL_Window &copy) : CL_Component(NULL, NULL) { return; } // disallow copy construction.
	class CL_Window_Generic *impl;
};  

#endif
