
#ifndef header_browse_client
#define header_browse_client

//! clanNetwork="Browsing"

#include "../signals.h"
#include <string>
class CL_IPAddress;

class CL_BrowseClient
//: Browse client to a browse master.
// The browse client is used to connect to a browse master and get a list of registered
// applications. Using this information, the application can generate a list of available
// servers that the user can connect to.
{
//!Construction:
public:
	CL_BrowseClient(
		const CL_IPAddress &browse_master,
		const std::string &app_id);
	// Connect to browse master and start downloading getting browse list.

	virtual ~CL_BrowseClient();

//!Attributes:
public:
	CL_Signal_v2<const CL_IPAddress &, const std::string &> &sig_server_added();
	// Signal that is called when the browse client is notified about a server addition.

	CL_Signal_v2<const CL_IPAddress &, const std::string &> &sig_server_updated();
	// Signal that is called when the browse client is notified about a server update.

	CL_Signal_v1<const CL_IPAddress &> &sig_server_removed();
	// Signal that is called when the browse client is notified about a server removal.

//!Operations:
public:

//!Implementation:
private:
	class CL_BrowseClient_Generic *impl;
};

#endif
