
#ifndef header_browse_server
#define header_browse_server

//! clanNetwork="Browsing"

#include <string>
class CL_IPAddress;

class CL_BrowseServer
//: Browse server to a browse master.
// The browse service is used to register a server on a browse master.
{
//!Construction:
public:
	CL_BrowseServer(
		const CL_IPAddress &browse_master,
		const std::string &app_id,
		const CL_IPAddress &server_address,
		const std::string &description);
	// Connect to browse master and register ourselves with the passed server address
	// and description.
	
	virtual ~CL_BrowseServer();
	// Disconnect from browse master.

//!Attributes:
public:

//!Operations:
public:
	void set_description(const std::string &description);
	// Change the server description on the browse master.

//!Implementation:
private:
	class CL_BrowseServer_Generic *impl;
};

#endif
