/*
	$Id: netcomputer.h,v 1.6 2001/03/04 17:54:52 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! clanNetwork="NetSessions"

#ifndef header_netcomputer
#define header_netcomputer

#include "netsession.h"

class CL_NetComputer
//: Class representing a computer in a network game.
{
//!Construction:
public:
	CL_NetComputer();
	//: Creates an unattached netcomputer object.

	CL_NetComputer(const CL_NetComputer &copy);
	//: Creates an attached netcomputer object.

	virtual ~CL_NetComputer();

//!Attributes:
public:
	unsigned long get_address() const;
	//: Returns the IP address (in network byte order) of the computer.

	CL_NetSession get_session();
	//: Returns the netsession that the computer is attached to.

	bool operator == (const CL_NetComputer &other_instance);

//!Operations:
public:
	void disconnect();
	//: Disconnects the computer from server.

	CL_NetComputer &operator = (const CL_NetComputer &other_instance);

//!Implementation:
public:
	CL_NetComputer(class CL_NetComputer_Generic *impl);
	class CL_NetComputer_Generic *impl;
};

#endif
