/*
	$Id: netgroup.h,v 1.6 2001/03/04 17:54:52 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! clanNetwork="NetSessions"

#ifndef header_netgroup
#define header_netgroup

#include <list>
#include "netcomputer.h"

class CL_NetGroup
//: Class used to group computers in a network game.
{
//!Construction:
public:
	CL_NetGroup();
	//: Construct an empty group list.

	CL_NetGroup(const CL_NetComputer &computer);
	//: Construct a group with one computer in it.

	virtual ~CL_NetGroup();

//!Attributes:
public:
	std::list<CL_NetComputer> &get_computers() const;
	//: List of computers in this group.

//!Operations:
public:
	void add(const CL_NetComputer &computer);
	//: Add computer to group.

	void remove(const CL_NetComputer &computer);
	//: Remove computer from group.

	void disconnect();
	// Disconnects all computers in group.

//!Implementation:
private:
	class CL_NetGroup_Generic *impl;
};

#endif
