/*
	$Id: subchannel.h,v 1.8 2001/03/17 07:29:34 vaidhy Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_subchannel
#define header_subchannel

//! clanNetwork="NetObjects"

#include "../signals.h"

class CL_SubChannel
//: Netchannel dispatcher.
// Dispatches incoming messages on a netchannel to slots connected to the subchannel.
{
public:
	CL_SubChannel(const CL_SubChannel &copy);
	CL_SubChannel(int netchannel);
	virtual ~CL_SubChannel();

	CL_Slot connect(int subchannel, CL_Slot_v1<const class CL_NetMessage &> *slot);
	void disconnect(int subchannel, CL_Slot &slot);

public:
	class CL_SubChannel_Generic *impl;
};

#endif
