
#ifndef header_jpgd_provider
#define header_jpgd_provider

#include "../Display/Display/surfaceprovider.h"
#include <string>

class CL_InputSourceProvider;
class CL_Palette;

class CL_JPGDProvider : public CL_SurfaceProvider
{
public:
	CL_JPGDProvider(
		const std::string &filename,
		CL_InputSourceProvider *provider = 0);

	~CL_JPGDProvider();
		
	virtual void lock();
	
	virtual void unlock();

	virtual void *get_data() const;

	virtual unsigned int get_num_frames() const;

	virtual unsigned int get_width() const;

	virtual unsigned int get_height() const;

	virtual unsigned int get_pitch() const;

	virtual unsigned int get_bytes_per_pixel() const;

	virtual bool is_indexed() const;

	virtual unsigned int get_red_mask() const;

	virtual unsigned int get_green_mask() const;

	virtual unsigned int get_blue_mask() const;

	virtual unsigned int get_alpha_mask() const;

	virtual CL_Palette *get_palette() const;

	virtual bool uses_src_colorkey() const;

	virtual unsigned int get_src_colorkey() const;

private:
	std::string filename;
	CL_InputSourceProvider *provider;
	unsigned int width, height, components;
	unsigned int *data;
	int ref_count;
};

#endif
