/*
	$Id: vorbis_soundprovider.h,v 1.7 2001/03/06 20:45:16 japj Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! clanVorbis="Sound Providers"

#ifndef header_vorbis_soundprovider
#define header_vorbis_soundprovider

#include "../core.h"
#include "../Sound/stream_soundprovider.h"
#include "../Sound/soundbuffer.h"


class CL_VorbisSoundProvider : public CL_StreamSoundProvider
{
public:
	CL_VorbisSoundProvider(
		const std::string &name,
		CL_InputSourceProvider *provider = NULL,
		bool delete_provider = false);

	CL_VorbisSoundProvider(
		const std::string &name,
		CL_ResourceManager *resources);

	virtual ~CL_VorbisSoundProvider();

	virtual CL_StreamSoundProvider_Session *begin_session();
	virtual void end_session(CL_StreamSoundProvider_Session *session);

private:
	CL_VorbisSoundProvider(const CL_VorbisSoundProvider &copy) { return; } // disallow copy construction.
	class CL_VorbisSoundProvider_Generic *impl;
};

#endif
