/*
	 $Id: core.h,v 1.29 2001/04/03 14:39:12 sphair Exp $

	 ------------------------------------------------------------------------
	 ClanLib, the platform independent game SDK.

	 This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	 version 2. See COPYING for details.

	 For a total list of contributers see CREDITS.

	 ------------------------------------------------------------------------
*/

#ifndef header_core
#define header_core

#define CL_VERSION(x,y,z)	( (x << 16) | (y << 8) | (z) )
#define CL_CURRENT_VERSION	CL_VERSION(0,5,0)
#define CL_VERSION_STRING "0.5.0"
#define CL_RELEASE_NAME "Halfway there"

#ifdef WIN32
#pragma warning( disable : 4786)
#endif

#ifdef __BORLANDC__
#define BORLAND
#endif

#include "Core/System/setupcore.h"
#include "Core/System/keep_alive.h"
#include "Core/System/system.h"
#include "Core/System/cl_assert.h"
#include "Core/System/error.h"
#include "Core/System/thread.h"
#include "Core/System/mutex.h"
#include "Core/System/clanstring.h"
#include "Core/System/timer.h"
#include "Core/System/event_listener.h"
#include "Core/System/event_trigger.h"
#include "Core/System/console_window.h"

#include "Core/IOData/cl_endian.h"
#include "Core/IOData/inputsource.h"
#include "Core/IOData/inputsource_file.h"
#include "Core/IOData/inputsource_memory.h"
#include "Core/IOData/inputsource_provider.h"
#include "Core/IOData/inputsource_provider_file.h"
#include "Core/IOData/outputsource.h"
#include "Core/IOData/outputsource_file.h"
#include "Core/IOData/outputsource_memory.h"
#include "Core/IOData/outputsource_provider.h"

#include "Core/Resources/resource_manager.h"
#include "Core/Resources/resourcetype.h"
#include "Core/Resources/resource.h"
#include "Core/Resources/resourceoptions.h"
#include "Core/Resources/resourceoption.h"
#include "Core/Resources/resourcetype_boolean.h"
#include "Core/Resources/resourcetype_integer.h"
#include "Core/Resources/resourcetype_string.h"
#include "Core/Resources/resourcetype_raw.h"
#include "Core/Resources/datafile_compiler.h"

#include "Core/Math/cl_vector.h"
#include "Core/Math/bezier.h"
#include "Core/Math/math.h"
#include "Core/Math/rect.h"
#include "Core/Math/size.h"
#include "Core/Math/point.h"

#endif
