/*
	 ------------------------------------------------------------------------
	 ClanLib, the platform independent game SDK.

	 This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	 version 2. See COPYING for details.

	 For a total list of contributers see CREDITS.

	 ------------------------------------------------------------------------
*/

#ifndef header_sound_api
#define header_sound_api

#include "Sound/setupsound.h"
#include "Sound/sound.h"
#include "Sound/soundformat.h"
#include "Sound/static_soundprovider.h"
#include "Sound/stream_soundprovider.h"
#include "Sound/soundbuffer_session.h"
#include "Sound/soundbuffer.h"
#include "Sound/cd_audio.h"
#include "Sound/soundfilter.h"

#include "Sound/SoundProviders/static_provider_wave.h"
#include "Sound/SoundProviders/static_provider_raw.h"
#include "Sound/SoundProviders/stream_provider_wave.h"
#include "Sound/SoundProviders/stream_provider_raw.h"

#include "Sound/SoundFilters/echofilter.h"
#include "Sound/SoundFilters/inverse_echofilter.h"
#include "Sound/SoundFilters/fadefilter.h"

#endif
